//
//  DataStatistics.m
//  Contact_Prisoner_Dilemma
//
//  Created by Juan E. Keymer on 11/1/09.
//  Copyright 2009 Delft University of Technology . All rights reserved.
//

#import "DataStatistics.h"


@implementation DataStatistics
	

- (id)init
{
    self = [super init];
    if (self) {
        [self setPoints:[NSArray array]];
    }
    return self;
}

- (void)dealloc 
{
    [self setPoints:nil];
    [super dealloc];
}

- (NSArray *)points 
{
    return points;
}

- (void)setPoints:(NSArray *)newPoints 
{
    [newPoints retain];
    [points release];
    points = newPoints;
}

- (NSString *)windowNibName
{
    return @"MyDocument";
}



- (BOOL)writeToURL:(NSURL *)absoluteURL ofType:(NSString *)typeName 
			 error:(NSError **)outError
{
    NSMutableString *csvString = [NSMutableString string];
    NSEnumerator *pointEnum = [points objectEnumerator];
    id point;
    while ( point = [pointEnum nextObject] ) {
        NSNumber *generation = [point valueForKey:@"generation"];
		 NSNumber *vacancy = [point valueForKey:@"vacancy"];
		 NSNumber *cooperators = [point valueForKey:@"cooperators"];
        NSNumber *cheaters = [point valueForKey:@"cheaters"];
        [csvString appendString:[NSString stringWithFormat:@"%@,%@,%@,%@\n", 
								 generation,vacancy,cooperators, cheaters]];
    }
    return [csvString writeToURL:absoluteURL atomically:NO 
						encoding:NSUTF8StringEncoding error:outError];
}

- (BOOL)readFromURL:(NSURL *)absoluteURL ofType:(NSString *)typeName 
			  error:(NSError **)outError 
{
    NSString *fileString = [NSString stringWithContentsOfURL:absoluteURL 
													encoding:NSUTF8StringEncoding error:outError];
    if ( nil == fileString ) return NO;
    NSScanner *scanner = [NSScanner scannerWithString:fileString];
    [scanner setCharactersToBeSkipped:
	 [NSCharacterSet characterSetWithCharactersInString:@"\n, "]];
    NSMutableArray *newPoints = [NSMutableArray array];
    float generation,vacancy,cooperators, cheaters;
    while ( [scanner scanFloat:&generation] && [scanner scanFloat:&vacancy]&& [scanner scanFloat:&cooperators]&& [scanner scanFloat:&cheaters] ) {
        [newPoints addObject:
		 [NSMutableDictionary dictionaryWithObjectsAndKeys:
		  [NSNumber numberWithFloat:generation], @"generation",
		  [NSNumber numberWithFloat:vacancy], @"vacancy",
		   [NSNumber numberWithFloat:cooperators], @"cooperators",
		   [NSNumber numberWithFloat:cheaters], @"cheaters",
		  nil]];
    }
    [self setPoints:newPoints];
    return YES;
}


@end
