#import "My_CPPD_controller.h"
#import "My_CPPD_Space_View.h"
#import "My_CPPD_SpaceTransectTime_View.h"
#import "DataStatistics.h"


//#import "gnuplot_i.h"

@implementation My_CPPD_controller



- (void)awakeFromNib
	{
		// initialize and allocate memory for a lattice simulation object	
		simulation  = [[My_CPPD_Lattice alloc] init];
		// initialize and allocate memory for a  Documment class object to handle time series data
		simulation_stats = [[DataStatistics alloc] init];
		 
		// default parameters for simulator
		init_option = 0; 
		Y_transect_location = 128;
		parametros[0] = 1.999; parametros[1] = 0.55;  
   
		time_series =[[Time_Point_Data_Array_controller alloc] init];
		
		//	[Time_Point_Data_Array_controller newObject];
		[time_series add:[time_series newObject]];
		
		//gnuplot_ctrl * h;
		//h = gnuplot_init();
    	//gnuplot_cmd(h, "plot sin(x)");
		//gnuplot_close(h) ;
	}

- (IBAction)setParameter_b:(id)sender {
    if ( sender == parameter_b_TextField ) 
	{
        parametros[0] = [parameter_b_TextField floatValue];
     	[parameter_b_TextField setFloatValue:parametros[0]]; 
	};

	
	
}// set parameter b in the PD

- (IBAction)setParameter_d:(id)sender {
    if ( sender == parameter_d_TextField ) 
	{
        parametros[1] = [parameter_d_TextField floatValue];
     	[parameter_d_TextField setFloatValue:parametros[1]]; 
	};
}// set parameter delta_0

- (void) setInitOption_0:(id)sender {init_option = 0;}
- (void) setInitOption_1:(id)sender {init_option = 1;}
- (void) setInitOption_2:(id)sender {init_option = 2;}



- (IBAction) startAnimation:(id)pId{
	if (nsTimerRef ) {
		[nsTimerRef invalidate];
		nsTimerRef	= nil; 
	}
	nsTimerRef	= [NSTimer	scheduledTimerWithTimeInterval:0.05 
													target:self
												  selector:@selector(animation_loop) 
												  userInfo:NULL 
												   repeats:YES];
	}// starts animation



- (IBAction) stopAnimation:(id)pId {
	[nsTimerRef invalidate];
	nsTimerRef	= nil;
} // end stopAnimation


- (IBAction) quitProgram:(id)pId{[NSApp terminate:self];};//quit app


-(void) animation_loop{
	float p_0,p_1,p_2;
	//	calculate things up
	[simulation update_Lattice_Configuration:(double) [parameter_b_TextField floatValue]:(double) [parameter_d_TextField floatValue]];
	[simulation push_SpaceTransectTimeBuffer:(int)Y_transect_location];
	[simulation increase_generation];
	//	update the displays (views)
	[Space_View paintLatticeBitmap:simulation];
	[SpaceTime_View paintTransectBitmap:simulation];
	// vomit console data
	//NSLog(@"\t generation:= %i \n\n", [simulation get_generation]);
	p_0= (float)([simulation get_state_proportions:0]/(float)(X_SIZE*Y_SIZE));
	p_1=(float)([simulation get_state_proportions:1]/(float)(X_SIZE*Y_SIZE));
	p_2= (float)([simulation get_state_proportions:2]/(float)(X_SIZE*Y_SIZE));
	//NSLog(@"\t proportions:= %f \t %f \t %f \t %f \n", p_0,p_1,p_2);
	NSLog(@"%i \t %f \t %f \t %f",[simulation get_generation], p_0,p_1,p_2);

	} // this is my local simulation loop


- (IBAction) initConfiguration:(id)pId {
	float p_0,p_1,p_2; int time;

	
	[simulation lattice_Initialize:init_option];	
	[simulation push_SpaceTransectTimeBuffer:(int)Y_transect_location];
	[Space_View paintLatticeBitmap:simulation];
	[SpaceTime_View paintTransectBitmap:simulation];
	// vomit console data
//	NSLog(@"\t generation:= %i \n", [simulation get_generation]);
	time = [simulation get_generation];
	p_0= (float)([simulation get_state_proportions:0]/(float)(X_SIZE*Y_SIZE));
	p_1=(float)([simulation get_state_proportions:1]/(float)(X_SIZE*Y_SIZE));
	p_2= (float)([simulation get_state_proportions:2]/(float)(X_SIZE*Y_SIZE));
//	[DataStatistics writeToURL:[simulation_stats newObject]];
	
//	[Time_Point_Data_Array_controller newObject];
	
//	NSLog(@"\t proportions:= %f \t %f \t %f \t %f \n", p_0,p_1,p_2);
	//[self make_gnuplot_serie];
} //init



- (IBAction)setYPosition:(id)sender
{
	Y_transect_location = (int)(T_SIZE-[sender floatValue]);
}


@end
