//
//  My_CPPD_Lattice.h
//  Contact_Prisoner_Dilemma
//
//  Created by Juan E. Keymer on 7/1/09.
//  Copyright 2009 Delft University of Technology . All rights reserved.
//

#import <Cocoa/Cocoa.h>

# define X_SIZE 256
# define Y_SIZE 256
# define T_SIZE 256

//# define T 1.0 + b
//# define R 1.0
//# define P 0.0
//# define S -1.0


@interface My_CPPD_Lattice : NSObject 
{		float state_proportions[3];
		int	generation;
		int LatticeConfiguration[ (int)X_SIZE][(int)Y_SIZE];
		int SpaceTransectTimeBuffer[(int)X_SIZE][(int) T_SIZE];
	}


-(void) push_SpaceTransectTimeBuffer:(int) at_y;
-(void) increase_generation;
-(void) lattice_Initialize:(int) option;
-(void) update_Lattice_Configuration:(double) temptation_bias:(double) background_mortality;

-(int) get_state_proportions:(int)state;
-(int) get_generation;
-(int) get_state_at:(int) at_x :(int) at_y; 
-(int) get_state_from_transect_buffer:(int) at_x:(int) at_t;

-(double) calculate_mortality:(int) focal_state:(int) adjacent_state:(double) temptation_bias: (double)background_mortality;

@end
