//
//  My_CPPD_Lattice.m
//  Contact_Prisoner_Dilemma
//
//  Created by Juan E. Keymer on 7/1/09.
//  Copyright 2009 Delft University of Technology . All rights reserved.
//


# include "mt19937.h"  //# include <stdio.h> already included in mt19937.h
# include <stdlib.h>
# include <time.h>
# include <math.h>

#import "My_CPPD_Lattice.h"


@implementation My_CPPD_Lattice

-(void) increase_generation{generation ++;};


- (void)awakeFromNib {
	//initialize the spatiotemporal buffer
	//NSInteger x; NSInteger y; NSInteger z;
	//for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x < (int)X_SIZE; x++)for (z = 0; z < (int)T_SIZE; z++) SpaceTimeBuffer[x][y][z] = 0;
	
	generation =0; 
	
	//state_proportions[0] = 0;
	//state_proportions[1] = 0;
	//state_proportions[2] = 0;
	
	unsigned int iseed = (unsigned int)time(NULL);
	sgenrand(iseed); /* any nonzero integer can be used as a seed */
}

-(void) push_SpaceTransectTimeBuffer:(int) y_location{
	NSInteger x; NSInteger y; NSInteger z; 
	//int	y_location =  128;
//	for (z = (int)T_SIZE-1; z =0 ; z--) 
//		for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x < (int)X_SIZE; x++)SpaceTimeBuffer[x][y][z] = SpaceTimeBuffer[x][y][z+1];


	if(generation < (int)T_SIZE )
	{
		for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x < (int)X_SIZE; x++)SpaceTransectTimeBuffer[x][generation]= LatticeConfiguration[x][(int)y_location];
	}else{
		for (z = 0; z <(int)T_SIZE-1 ; z++) 
			for (x = 0; x < (int)X_SIZE; x++)SpaceTransectTimeBuffer[x][z] = SpaceTransectTimeBuffer[x][z+1];
			for (x = 0; x < (int)X_SIZE; x++)SpaceTransectTimeBuffer[x][(int)T_SIZE-1]= LatticeConfiguration[x][(int)y_location];
	}
};





-(void)lattice_Initialize:(int)choice
{
		generation =0; 
		
		state_proportions[0] = 0;
		state_proportions[1] = 0;
		state_proportions[2] = 0;
		NSInteger x; NSInteger y;
		for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x < (int)X_SIZE; x++) {LatticeConfiguration[x][y] = 0 ;}
	switch (choice) {
		case 0:
			LatticeConfiguration[128+50][128] = 1;//state_proportions[1]++;
			LatticeConfiguration[127+50][128] = 1;//state_proportions[1]++;
			LatticeConfiguration[129+50][128] = 1;//state_proportions[1]++;
			LatticeConfiguration[128+50][127] = 1;//state_proportions[1]++;
			LatticeConfiguration[128+50][129] = 1;//state_proportions[1]++;
			
			LatticeConfiguration[128-50][128] = 2;//state_proportions[2]++;
			LatticeConfiguration[129-50][128] = 2;//state_proportions[2]++;
			LatticeConfiguration[127-50][128] = 2;//state_proportions[2]++;
			LatticeConfiguration[128-50][127] = 2;//state_proportions[2]++;
			LatticeConfiguration[128-50][129] = 2;//state_proportions[2]++;
			break;
		
		case 1: 
			
			for (x = 0; x < (int)X_SIZE; x++) {LatticeConfiguration[x][128-50] = 1;LatticeConfiguration[x][128+50] = 2;}
			break;
		case 2:
			for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x < (int)X_SIZE; x++) 
			{ 
				if(genrand() < 0.99){ LatticeConfiguration[x][y]=0;	}
				else{switch((int)ceil((genrand()*2)))
						{
						case 1:LatticeConfiguration[x][y]=1; break;
						case 2:	LatticeConfiguration[x][y]=2; break;
						}
				}
			};
			break; 
	
		default:
			break;
			
			
	}	
			
		
for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x < (int)X_SIZE; x++) state_proportions[(int)LatticeConfiguration[x][y]]++;
	}


-(int)get_state_at:(int) at_x:(int) at_y{return LatticeConfiguration[at_x][at_y];}

-(int)get_state_from_transect_buffer:(int) at_x:(int) at_t{return SpaceTransectTimeBuffer[at_x][at_t];}

-(int)get_generation{return generation;};


-(void) update_Lattice_Configuration:(double) temptation_bias:(double) background_mortality
	{
		float random_neighbor; 
		int random_x_coor, random_y_coor;
		//NSInteger x; NSInteger y,
		int sites;
		
		// FOR as many as lattice sites:
		for (sites = 0; sites < (int)(Y_SIZE*X_SIZE); sites++)
		{
			//pick a random focal site:
			random_x_coor = (int) floor(genrand()*X_SIZE);
			random_y_coor = (int) floor(genrand()*Y_SIZE);
					
			// pick a relative random neighbor of the focus site:	
			switch((int) ceil((genrand()*4)))
				{
				case 1: //south
					random_neighbor = LatticeConfiguration[random_x_coor][(int)((Y_SIZE + random_y_coor-1)%Y_SIZE)]; break;
				case 2: //north
					random_neighbor = LatticeConfiguration[random_x_coor][(int)((Y_SIZE + random_y_coor+1)%Y_SIZE)];break;
				case 3: //east
					random_neighbor = LatticeConfiguration[(int)((X_SIZE + random_x_coor-1)%X_SIZE)][random_y_coor];break;
				case 4: //west
					random_neighbor = LatticeConfiguration[(int)((X_SIZE + random_x_coor+1)%X_SIZE)][random_y_coor];break;
				}
			
			//depending on the state of the focus site:
			switch( (int) LatticeConfiguration[random_x_coor][random_y_coor])
			{ 
				case 0:				// empty site at focus
					// if its random neighbor is occupied: put a copy at the focal site corresponding to the adjacent player: 1(defect) or 2 (cooperate)
					if ( random_neighbor != 0)
						{LatticeConfiguration[random_x_coor][random_y_coor] =  random_neighbor;
						state_proportions[(int)random_neighbor]++;
						state_proportions[0]--;
						}
					break;
				case 1:				// cooperate (green/particle 1)
					if ( random_neighbor == 0  && genrand() < background_mortality) 
							{	
							state_proportions[(int)LatticeConfiguration[random_x_coor][random_y_coor]]--;
							LatticeConfiguration[random_x_coor][random_y_coor] = 0;	
							state_proportions[0]++;}
					
					if ( random_neighbor == 1 && random_neighbor != -1 && genrand() < [self calculate_mortality:(int)1:(int)1:temptation_bias:background_mortality]) 
					{
						
						state_proportions[(int)LatticeConfiguration[random_x_coor][random_y_coor]]--;
						LatticeConfiguration[random_x_coor][random_y_coor] =0;
						state_proportions[0]++;
					}
						if ( random_neighbor == 2 && genrand() < [self calculate_mortality:(int)1:(int)2:temptation_bias:background_mortality]) 
						{	
							state_proportions[(int)LatticeConfiguration[random_x_coor][random_y_coor]]--;
							LatticeConfiguration[random_x_coor][random_y_coor] =0;
							state_proportions[0]++;

						}

					break;	
				case 2:				// defector (red/particle 2)
					
					if ( random_neighbor == 0 &&  genrand() < background_mortality) 
					{	
						state_proportions[(int)LatticeConfiguration[random_x_coor][random_y_coor]]--;
						LatticeConfiguration[random_x_coor][random_y_coor] =0;
						state_proportions[0]++;
					}
					
					if ( random_neighbor == 1 && genrand() < [self calculate_mortality:2:1:temptation_bias:background_mortality])
						{
						state_proportions[(int)LatticeConfiguration[random_x_coor][random_y_coor]]--;
						LatticeConfiguration[random_x_coor][random_y_coor] = 0;
						state_proportions[0]++;
						}
					if ( random_neighbor == 2 && genrand() < [self calculate_mortality:2:2:temptation_bias:background_mortality]) 
							{	
								state_proportions[(int)LatticeConfiguration[random_x_coor][random_y_coor]]--;
								LatticeConfiguration[random_x_coor][random_y_coor] =0;
								state_proportions[0]++;
							}
					break;					
			};
		}
	}



-(double) calculate_mortality:(int) focal_state:(int) adjacent_state:(double) temptation_bias:(double)background_mortality
{	
		double value;
		double PD_Matrix[2][2];

	
		
		PD_Matrix[0][0]  = 1.0; // Reward Pay-off
		PD_Matrix[1][1]  = 0.0; // Punishment Pay-off
		PD_Matrix[1][0]  = (1.0 + temptation_bias) ;	// Temptation Pay-off
		PD_Matrix[0][1]	 = (-1.0);						// Suckers Pay-off

	value = background_mortality - (1 - background_mortality)*(PD_Matrix[focal_state-1][adjacent_state-1])/(1 + temptation_bias) ;

	
	return value;}

-(int) get_state_proportions:(int)state{return state_proportions[state];};

@end
