//
//  My_CPPD_SpaceTransectTime_View.m
//  Contact_Prisoner_Dilemma
//
//  Created by Juan E. Keymer on 7/1/09.
//  Copyright 2009 Delft University of Technology . All rights reserved.
//

#import "My_CPPD_SpaceTransectTime_View.h"


@implementation My_CPPD_SpaceTransectTime_View



- (id)initWithFrame:(NSRect)pFrameRect 
{	
    if (! (self = [super initWithFrame:pFrameRect]))
	{
        NSLog(@"MyView initWithFrame *Error*");
		return self;
    } // end if
	
	nsRectFrameRect	= pFrameRect;
	return self;
}


- (void)awakeFromNib {
	
	nsBitmapImageRepObj = [[NSBitmapImageRep alloc]
						   initWithBitmapDataPlanes:NULL
						   pixelsWide:nsRectFrameRect.size.width 
						   pixelsHigh:nsRectFrameRect.size.height
						   bitsPerSample:8 
						   samplesPerPixel:3 
						   hasAlpha:NO 
						   isPlanar:NO 
						   colorSpaceName:@"NSCalibratedRGBColorSpace" 
						   bytesPerRow:0 
						   bitsPerPixel:0];	
} // end awakeFromNib


- (void)drawRect:(NSRect)pRect {
	
	[NSGraphicsContext saveGraphicsState];
	[nsBitmapImageRepObj drawInRect:pRect]; 	
	[NSGraphicsContext restoreGraphicsState];
	
} // end drawRect



- (void) paintDefaultBitmap {
	
	NSUInteger zIntRed	 = 255;
	NSUInteger zIntGreen = 255;
	NSUInteger zIntBlue  = 255;
	NSInteger x; 
	NSInteger z; 
	
	
	for (z = 0; z < T_MAX; z++)for (x = 0; x < X_MAX; x++) 
	{ 
		zIntRed	 = 0; 
		zIntGreen =  0;
		zIntBlue  = 255;
		NSUInteger zColourAry[3];
		zColourAry[0] = zIntRed;
		zColourAry[1] = zIntGreen;
		zColourAry[2] = zIntBlue;
		[nsBitmapImageRepObj setPixel:zColourAry atX:x y:z];
	}
	[self setNeedsDisplay:YES];
}	// paint a default bitmap



-(void)paintTransectBitmap:(My_CPPD_Lattice *) simulation_state
	{
	NSUInteger zIntRed	 = 255;
	NSUInteger zIntGreen = 255;
	NSUInteger zIntBlue  = 255;
	NSInteger x; 
	NSInteger t; 
	NSUInteger zColourAry[3];
	
	for (t = 0; t < T_MAX; t++)for (x = 0; x < X_MAX; x++) 
	{  switch([simulation_state get_state_from_transect_buffer:x:t])
		{  
				
			case -1:
				zIntRed	 = 0; 
				zIntGreen = 0;
				zIntBlue  = 255;
				break;
				
			case 0:
				zIntRed	 = 0; 
				zIntGreen = 0;
				zIntBlue  = 0;
				break;
			case 1:
				zIntRed	 = 0; 
				zIntGreen = 255;
				zIntBlue  = 0;
				break; 
			case 2: 
				zIntRed	  = 255; 
				zIntGreen = 0;
				zIntBlue  = 0;
				break; 
			//default:
			//	break;
		}
		zColourAry[0] = zIntRed;
		zColourAry[1] = zIntGreen;
		zColourAry[2] = zIntBlue;
		
		[nsBitmapImageRepObj setPixel:zColourAry atX:x y:t];
	}
	[self setNeedsDisplay:YES];	
};	// paints a bitmap from a lattice configuration

@end
