//
//  My_CPPD_Space_View.m
//  Contact_Prisoner_Dilemma
//
//  Created by Juan E. Keymer on 6/29/09.
//  Copyright 2009 Delft University of Technology . All rights reserved.
//

#import "My_CPPD_Space_View.h"


@implementation My_CPPD_Space_View


- (id)initWithFrame:(NSRect)pFrameRect 
{	
    if (! (self = [super initWithFrame:pFrameRect]))
	{
        NSLog(@"MyView initWithFrame *Error*");
		return self;
    } // end if
	
	nsRectFrameRect	= pFrameRect;
	return self;
}


- (void)awakeFromNib {
	
	nsBitmapImageRepObj = [[NSBitmapImageRep alloc]
						   initWithBitmapDataPlanes:NULL
						   pixelsWide:nsRectFrameRect.size.width 
						   pixelsHigh:nsRectFrameRect.size.height
						   bitsPerSample:8 
						   samplesPerPixel:3 
						   hasAlpha:NO 
						   isPlanar:NO 
						   colorSpaceName:@"NSCalibratedRGBColorSpace" 
						   bytesPerRow:0 
						   bitsPerPixel:0];	
} // end awakeFromNib


- (void)drawRect:(NSRect)pRect {
	
	[NSGraphicsContext saveGraphicsState];
	[nsBitmapImageRepObj drawInRect:pRect]; 	
	[NSGraphicsContext restoreGraphicsState];
	
} // end drawRect


- (void) paintDefaultBitmap {
	
	NSUInteger zIntRed	 = 255;
	NSUInteger zIntGreen = 255;
	NSUInteger zIntBlue  = 255;
	NSInteger x; 
	NSInteger y; 
	
	
	for (y = 0; y < Y_MAX; y++)for (x = 0; x < X_MAX; x++) 
			{ 
			zIntRed	 = 0; 
			zIntGreen =  0;
			zIntBlue  = 255;
			NSUInteger zColourAry[3];
			zColourAry[0] = zIntRed;
			zColourAry[1] = zIntGreen;
			zColourAry[2] = zIntBlue;
			[nsBitmapImageRepObj setPixel:zColourAry atX:x y:y];
			}
	[self setNeedsDisplay:YES];
}	// paint a default bitmap


-(void)paintLatticeBitmap:(My_CPPD_Lattice *) simulation_state
	{
		NSUInteger zIntRed	 = 255;
		NSUInteger zIntGreen = 255;
		NSUInteger zIntBlue  = 255;
		NSInteger x; 
		NSInteger y; 
		NSUInteger zColourAry[3];
		
		for (y = 0; y < Y_MAX; y++) for (x = 0; x < X_MAX; x++) 
			{  switch([simulation_state get_state_at:x:y])
				{
						
					case -1:
						zIntRed	 = 0; 
						zIntGreen = 0;
						zIntBlue  = 255;
						break;	
					case 0:
						zIntRed	 = 0; 
						zIntGreen = 0;
						zIntBlue  = 0;
						break;
					case 1:
						zIntRed	 = 0; 
						zIntGreen = 255;
						zIntBlue  = 0;
						break; 
					case 2: 
						zIntRed	 = 255; 
						zIntGreen = 0;
						zIntBlue  = 0;
						break; 
					default:
					break;
				}
				zColourAry[0] = zIntRed;
				zColourAry[1] = zIntGreen;
				zColourAry[2] = zIntBlue;
	
				[nsBitmapImageRepObj setPixel:zColourAry atX:x y:y];
			}
		[self setNeedsDisplay:YES];	
	};	// paints a bitmap from a lattice configuration

+(void)makeBeep{NSBeep();}

@end